


//In this script I tried to define the relationship between the scale (HX711) and the NeoPixel Ring.

//The goal is to fill and colour the NeoPixel Ring in a way that depicts how much of the current ingredient is already in the bowl.
    //(e.g. half full circle, if half of the desired amount is in the bowl). 
    //The following connection/relationship would be amazing (with smooth transitions): 
      // purple: nearly no ingredient at all (~ 2 pixels are switched on in purple)
      // red: 1/4 of the desired amount (this also means that 1/4 of the ring is switched on)
      // orange: 1/2 of the desired amount
      // Yellow: 2/3 of the desired amount
      // Light Green: 3/4 of the desired amount
      // Dark Green: we are here! (complete desired amount)
      // Green blinking (complete circle): Perfect, done for that ingredient!
      // Red blinking (complete Circle): Too much, put some out again!

//RESOURCES:
//https://learn.adafruit.com/florabrella/test-the-neopixel-strip
      
      
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////INCLUDING LIBRARIES AND PINS ////////////////////////


//Scale////////////////////////////////////////////////////////////////
#include "HX711.h"

// define pins
#define calibration_factor 16000000 //This value is obtained using the SparkFun_HX711_Calibration sketch 
#define DOUT  3
#define CLK  2
HX711 scale;

//Neopixel//////////////////////////////////////////////////////////////
#include <Wire.h>
#include <RTClib.h>
#include <Adafruit_NeoPixel.h>
#include <PololuLedStrip.h>



// define pins
//PololuLedStrip <7> ledStrip;
#define NEOPIN 7
#define STARTPIXEL 0 // where do we start on the loop
#define LED_COUNT 60

Adafruit_NeoPixel strip = Adafruit_NeoPixel(LED_COUNT, NEOPIN, NEO_RGB + NEO_KHZ800); 


//rgb_color colors[LED_COUNT];
//I'm using this NeoPixel-Ring: https://coolcomponents.co.uk/products/60-led-172mm-ring-ws2812b-5050-rgb-led-with-integrated-drivers-adafruit-neopixel-compatible  )

// variables for colour values 
int w = 0;


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////SETUP ///////////////////////////////////////////////////////////////////////////////////////////////////////

void setup () {

  //Scale////////////////////////////////////////////////////////////////
  Serial.begin(9600);
  scale.begin(DOUT, CLK);
  scale.set_scale(calibration_factor); //This value is obtained by using the SparkFun_HX711_Calibration sketch
  scale.tare(); //Assuming there is no weight on the scale at start up, reset the scale to 0
  
  /*defining the desired weight per ingredient
    //first ingredient = 200gr flour
    //second ingredient = 200gr banana
    //third ingredient = 50gr sugar
    //fourth ingredient = 5gr baking soda
    //fifth ingredient = 3gr cinnamon
    //sixth ingredient = 3gr salt */
  
  ///Neopixel//////////////////////////////////////////////////////////////
  // set pinmodes
  pinMode(NEOPIN, OUTPUT);
  strip.begin();
  strip.show(); // Initialize all pixels to 'off'
  strip.setBrightness(50); // set brightness

}

/*// Converts a color from HSV to RGB.
// h is hue, as a number between 0 and 360.
// s is the saturation, as a number between 0 and 255.
// v is the value, as a number between 0 and 255.
rgb_color hsvToRgb(uint16_t h, uint8_t s, uint8_t v)
{
    uint8_t f = (h % 60) * 255 / 60;
    uint8_t p = (255 - s) * (uint16_t)v / 255;
    uint8_t q = (255 - f * (uint16_t)s / 255) * (uint16_t)v / 255;
    uint8_t t = (255 - (255 - f) * (uint16_t)s / 255) * (uint16_t)v / 255;
    uint8_t r = 0, g = 0, b = 0;
    switch((h / 60) % 6){
        case 0: r = v; g = t; b = p; break;
        case 1: r = q; g = v; b = p; break;
        case 2: r = p; g = v; b = t; break;
        case 3: r = p; g = q; b = v; break;
        case 4: r = t; g = p; b = v; break;
        case 5: r = v; g = p; b = q; break;
    }
    return rgb_color(r, g, b);
}*/
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////LOOP //////////////////////////////////////////////////////////////////////////////////////////////////////////

void loop () {

/////FIRST INGREDIENT ////


  
///
  while (scale.get_units()*40000 < 200) {               //as long as below desired weight 200
    Serial.print("Reading: ");                            //iteratively show what the scale is receiving as weight.
    Serial.print(scale.get_units()*40000, 1);            
    Serial.print(" grams");
    Serial.println();int pp = map(scale.get_units()*40000, 0,200,0,60);  //maps percentage of desired weight to percentage of pixels lit
    for (int i = 0; i < pp; i++) {                      //colour all pixels so that the percentage lit of the ring matches the percentage of desired weight reached
        uint16_t n, j;                                  //defining two integers
        for (int j = 0; j < 256; j++) {                 //iterate over the range of colour values
          uint16_t time = millis() >> 2;                // No idea what exactly this line does, but it makes the rainbow move
          byte x = (time >> 2) - (i << 3);            //No idea here at all. Something with time as well
          strip.Color((uint32_t)x * 359 / 256, 255, 255); // uses the function defined above to translate HSV clours to RGB 
         }                                                          //(why exactly does it work with HSV at all? Does it make rainbows easier?)
         //strip.Color(colours, i);

  // Write the colors to the LED strip.
  //strip.write(colors, LED_COUNT);                    //How can I set the brightness? They are too bright

  delay(10);
    
        
    } 
  }


                                                //In this block I want to make the ring blink green three times, as soon as the desired weight is reached
  while (w < 3) {
    for (int i = 0; i < 60; i++) {
     strip.Color(i, 0, 0, 255);         // I just want this line to fill the whole neopixel green. 
                                                    //I don't undersatnd how I can simply light the ring up in a predefined colour
    }   
     delay(100);   
     w++;
  }   
}

/*////////////FUNCTIONS 
void rainbow(uint8_t wait) {
  uint16_t n, j;
  for (int j = 0; j < 256; j++) {
    
    
    uint16_t time = millis() >> 2;
  for(uint16_t i = 0; i < LED_COUNT; i++)
  {
    byte x = (time >> 2) - (i << 3);
    colors[i] = hsvToRgb((uint32_t)x * 359 / 256, 255, 255);
  }

  // Write the colors to the LED strip.
  ledStrip.write(colors, LED_COUNT);

  delay(10);
    
    /*for (int n; n < 60; n++) {
    ledStrip.write( Weight((n+j) & 255), n);
    }
    ledStrip.show();
    delay(wait);
  }
}            

void rainbowCycle(uint8_t wait) {
  uint16_t time = millis() >> 2;
  for(uint16_t i = 0; i < LED_COUNT; i++)
  {
    byte x = (time >> 2) - (i << 3);
    colors[i] = hsvToRgb((uint32_t)x * 359 / 256, 255, 255);
  }

  // Write the colors to the LED strip.
  ledStrip.write(colors, LED_COUNT);
  
uint16_t i, j;
 
  for(j=0; j<256*5; j++) { // 5 cycles of all colors on wheel
    for(i=0; i< 60; i++) {
      ledStrip.write( Weight(((i * 256 / 60) + j) & 255), i);
    }
    ledStrip.show();
    delay(wait);
  }
}
/

// Input a value 0 to 255 to get a color value.
// The colours are a transition r - g - b - back to r.
uint32_t Weight(byte WeightAmount) {
  if(scale.get_units() < 20) {
   return ledStrip.write(WeightAmount * 3, 255 - WeightAmount * 3, 0);
  } else if(WeightAmount < 40) {
   WeightAmount -= 20;
   return ledStrip.write(255 - WeightAmount * 3, 0, WeightAmount * 3);
  } else {
   WeightAmount -= 60;
   return ledStrip.write(0, WeightAmount * 3, 255 - WeightAmount * 3);
  }
}


/*/
///INSERT: Display reaction via NRF24
